#ifndef h_sun
#define h_sun
#include <i.h>
#include <complex.h>
#include "sim.h"
struct light
{
char config_file[300];
int points;
int lpoints;
double *x;
double dx;
double **Ep;
double **Epz;
double **En;
double **Enz;
double **n;
double **alpha;
double **photons;
double **photons_asb;
int *layer;
double *sun_E;
int layers;
double ylen;
struct istruct *mat;
struct istruct *mat_n;
struct istruct sun_read;
double *sun;
double *sun_norm;
double *sun_photons;
double *thick;
int M;
int N;
int *Ti;
int *Tj;
double *Tx;
double *Txz;
double *b;
double *bz;
double lstart;
double lstop;
double *l;
double *Gn;
double *Gp;
double dl;
double laser_wavelength;
int laser_pos;
double ND;
double spotx;
double spoty;
double pulseJ;
double pulseL;
double lasereff;
double complex **t;
double complex **r;
int gather;
int *enable_gen;
int dump;
double *layer_end;
double device_start;
double *G_percent;
double dlength;
int align_mesh;
int device_start_layer;
int device_start_i;
};

void light_set_dump(struct light *in,int dump);
void light_load_config(struct light *in,char *config_file);
void light_free(struct light *in);
void light_dump(struct light *in);
int light_solve_lam_slice(struct light *in,int lam);
void light_set_dx(struct light *in,double dx);
#endif
